#include "config.h"
#include "misc.h"
#include "get_uid.h"

#include <stdio.h>

#define MAXFIELDS 20


void ip2hex(struct ip_address ip, char *result) {
        hexchar(ip.d[3],result);
        hexchar(ip.d[2],&result[2]);
        hexchar(ip.d[1],&result[4]);
        hexchar(ip.d[0],&result[6]);
}
                                                                                
void port2hex(uint16 port, char *result) {
        hexchar(port>>8,result);
        hexchar(port&255,&result[2]);
}

int get_uid(struct conn_info c) {
        char la[14], ra[14];
        FILE *inf;
        char line[200];
        int fields[MAXFIELDS], len;
        char *result;
                                                                                                                
        inf=fopen("/proc/net/tcp","r");
        if(!inf) return -1;
        ip2hex(c.laddr, la); la[8]=':'; port2hex(c.lport, &la[9]); la[13]='\0';
        ip2hex(c.raddr, ra); ra[8]=':'; port2hex(c.rport, &ra[9]); ra[13]='\0';
        result=fgets(line,sizeof(line),inf);
        if(!result) return H_UNKNOWN;                  /* no header? */
        while(1) {
                result=fgets(line,sizeof(line),inf);
                if(!result) break;
                len=strlen(line);
                tokenize(line,fields,8);
                if(fields[7]>=len) return -1; /* weird format */
                if((strcmp(&line[fields[1]],la)==0) &&
                   (strcmp(&line[fields[2]],ra)==0))
                        return atoi(&line[fields[7]]);
        }
        return H_NO_USER;
}
